fix monitor issue
[distro-setup] / brc
1 #!/bin/bash
2 # this gets sourced. shebang is just for file mode detection
3
4 # note, to catch errors in functions but not outside, do:
5 # set -E -o pipefail
6 # trap return ERR
7 # trap 'trap ERR' RETURN
8
9
10 # * settings
11
12 CDPATH=.
13
14 set -o pipefail
15
16 # remove all aliases. aliases provided by the system tend to get in the way,
17 # for example, error happens if I try to define a function the same name as an alias
18 unalias -a
19
20 # remove gnome keyring warning messages
21 # there is probably a more proper way, but I didnt find any easily on google
22 # now using xfce+xmonad instead of vanilla xmonad, so disabling this
23 #unset GNOME_KEYRING_CONTROL
24
25 # use extra globing features.
26 shopt -s extglob
27 # include .files when globbing, but ignore files name . and ..
28 # setting this also sets dotglob.
29 # Note, this doesnt work in bash 4.4 anymore, for paths with
30 # more than 1 directory, like a/b/.foo, since * is fixed to not match /
31 export GLOBIGNORE=*/.:*/..
32
33 # broken with bash_completion package. Saw a bug for this once. dont anymore.
34 # still broken in wheezy
35 # still buggered in latest stable from the web, version 2.1
36 # perhaps its fixed in newer git version, which fails to make for me
37 # this note is from 6-2014.
38 # Also, enabling this before sourcing .bashrc makes PATH be empty.
39 #shopt -s nullglob
40
41 # make tab on an empty line do nothing
42 shopt -s no_empty_cmd_completion
43
44 # advanced completion
45 # http://bash-completion.alioth.debian.org/
46 # might be sourced by the system already, but ive noticed it not being sourced before
47 if ! type _init_completion &> /dev/null && [[ -r "/usr/share/bash-completion/bash_completion" ]]; then
48 . /usr/share/bash-completion/bash_completion
49 fi
50
51
52 # fix spelling errors for cd, only in interactive shell
53 shopt -s cdspell
54 # append history instead of overwritting it
55 shopt -s histappend
56 # for compatibility, per gentoo/debian bashrc
57 shopt -s checkwinsize
58 # attempt to save multiline single commands as single history entries.
59 shopt -s cmdhist
60 # enable **
61 shopt -s globstar
62
63
64 # inside emcas fixes
65 if [[ $RLC_INSIDE_EMACS ]]; then
66 # EMACS is used by bash on startup, but we dont need it anymore.
67 # plus I hit a bug in a makefile which inherited it
68 unset EMACS
69 export RLC_INSIDE_EMACS
70 export PAGER=cat
71 export MANPAGER=cat
72 # scp completion does not work, but this doesnt fix it. todo, figure this out
73 complete -r scp &> /dev/null
74 # todo, remote file completion fails, figure out how to turn it off
75 export NODE_DISABLE_COLORS=1
76 # This gets rid of ugly terminal escape chars in node repl
77 # sometime, Id like to have completion working in emacs shell for node
78 # the offending chars can be found in lib/readline.js,
79 # things that do like:
80 # stream.write('\x1b[' + (x + 1) + 'G');
81 # We can remove them and keep readline, for example by doing this
82 # to start a repl:
83 #!/usr/bin/env nodejs
84 # var readline = require('readline');
85 # readline.cursorTo = function(a,b,c) {};
86 # readline.clearScreenDown = function(a) {};
87 # const repl = require('repl');
88 # var replServer = repl.start('');
89 #
90 # no prompt, or else readline complete seems to be confused, based
91 # on our column being different? node probably needs to send
92 # different kind of escape sequence that is not ugly. Anyways,
93 # completion doesnt work yet even with the ugly prompt, so whatever
94 #
95 export NODE_NO_READLINE=1
96
97 fi
98
99
100 if [[ $- == *i* ]]; then
101 # for readline-complete.el
102 if [[ $RLC_INSIDE_EMACS ]]; then
103 # all for readline-complete.el
104 stty echo
105 bind 'set horizontal-scroll-mode on'
106 bind 'set print-completions-horizontally on'
107 bind '"\C-i": self-insert'
108 else
109
110 # todo: not sure this works in sakura
111 #stty werase undef
112 #bind "\C-w": kill-region
113 # sakura == xterm-256color
114 # konsole == xterm
115 if [[ $TERM == "xterm" ]]; then
116 # control + arrow keys. for other terminals, see http://unix.stackexchange.com/questions/10806/how-to-change-previous-next-word-shortcut-in-bash
117 bind '"\e[1;5C": shell-forward-word' 2>/dev/null
118 bind '"\e[1;5D": shell-backward-word' 2>/dev/null
119 else
120 # make ctrl-backspace work. for konsole, i fixed it through
121 # /home/iank/.local/share/konsole/default.keytab
122 stty werase '^h'
123 bind '"\eOc": shell-forward-word'
124 bind '"\eOd": shell-backward-word'
125 fi
126 # i cant remember why i did this, probably to free up some keys to bind
127 # to other things in bash.
128 # other than C-c and C-z, the rest defined by stty -a are, at least in
129 # gnome-terminal, overridden by bash, or disabled by the system
130 stty lnext undef stop undef start undef
131 fi
132
133 fi
134
135
136 # history number. History expansion is good.
137 PS4='$LINENO+ '
138 # history file size limit, set to unlimited.
139 # this needs to be different from the default because
140 # default HISTFILESIZE is 500 and could clobber our history
141 HISTFILESIZE=
142 # max commands 1 session can append/read from history
143 HISTSIZE=100000
144 # my own history size limit based on lines
145 HISTFILELINES=1000000
146 HISTFILE=$HOME/.bh
147 # the time format display when doing the history command
148 # also, setting this makes the history file record time
149 # of each command as seconds from the epoch
150 HISTTIMEFORMAT="%Y-%m-%d %I:%M %p "
151 # consecutive duplicate lines dont go in history
152 HISTCONTROL=ignoredups
153 # works in addition to HISTCONTROL to do more flexible things
154 # it could also do the same things as HISTCONTROL and thus replace it,
155 # but meh. dunno why, but just " *" does glob expansion, so use [ ] to avoid it.
156 HISTIGNORE='pass *:[ ]*:lom*:gram*'
157
158 export BC_LINE_LENGTH=0
159
160
161 # note, if I use a machine I dont want files readable by all users, set
162 # umask 077 # If fewer than 4 digits are entered, leading zeros are assumed
163
164 C_DEFAULT_DIR=/a
165
166 # i for insensitive. the rest from
167 # https://superuser.com/questions/366930/how-do-i-get-the-git-pager-to-clean-up-screen-output-after-exit
168 # and reading the man
169 export LESS=RXi
170
171 # * include files
172 for _x in /a/bin/distro-functions/src/* /a/bin/!(githtml)/*-function?(s); do
173 source "$_x"
174 done
175 unset _x
176 # so I can share my bashrc
177 for x in /a/bin/bash_unpublished/source-!(.#*); do source $x; done
178 source $(dirname $(readlink -f $BASH_SOURCE))/path_add-function
179 source /a/bin/log-quiet/logq-function
180 if [[ -e /a/bin/errhandle/err ]]; then
181 source /a/bin/errhandle/err
182 err-allow
183 fi
184 # if someone exported $SOE (stop on error), catch errors
185 if [[ $SOE ]]; then
186 err-catch
187 fi
188
189 path_add /a/exe
190 # end just because it seems safer
191 path_add --end node_modules/.bin
192 # pip3 --user things go here:
193 path_add --end ~/.local/bin
194 path_add --ifexists --end /a/work/libremanage
195 path_add --ifexists --end /a/opt/adt-bundle*/tools /a/opt/adt-bundle*/platform-tools
196 path_add --ifexists --end /a/opt/scancode-toolkit-2.9.2
197 export WCDHOME=/a
198 # based on readme.debian. dunno if this will break on other distros.
199 _x=/usr/share/wcd/wcd-include.sh
200 if [[ -e $_x ]]; then source $_x; fi
201
202
203 # * aliases
204
205 # very few aliases, functions are always preferred.
206
207 # ancient stuff.
208 if [[ $OS == Windows_NT ]]; then
209 alias ffs='cygstart "/c/Program Files (x86)/Mozilla Firefox/firefox.exe" -P scratch'
210 export DISPLAY=nt
211 alias j='command cygpath'
212 alias t='command cygstart'
213 alias cygstart='echo be quick, use the alias "t" instead :\)'
214 alias cygpath='echo be quick, use the alias "j" instead :\)'
215 fi
216
217
218
219 # keep this in mind? good for safety.
220 # alias cp='cp -i'
221 # alias mv='mv -i'
222
223
224 # remove any default aliases for these
225 unalias ls ll grep &>/dev/null ||:
226
227
228
229 # * functions
230
231
232 ..() { c ..; }
233 ...() { c ../..; }
234 ....() { c ../../..; }
235 .....() { c ../../../..; }
236 ......() { c ../../../../..; }
237
238
239 # file cut copy and paste, like the text buffers :)
240 # I havnt tested these.
241 _fbufferinit() { # internal use by
242 ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
243 rm -rf "$my_f_tempdir"/*
244 }
245 fcp() { # file cp
246 _fbufferinit
247 cp "$@" "$my_f_tempdir"/
248 }
249 fct() { # file cut
250 _fbufferinit
251 mv "$@" "$my_f_tempdir"/
252 }
253 fpst() { # file paste
254 [[ $2 ]] && { echo too many arguments; return 1; }
255 target=${1:-.}
256 cp "$my_f_tempdir"/* "$target"
257 }
258
259
260 # todo, update this
261 complete -F _longopt la lower low rlt rld rl lld ts ll dircp ex fcp fct fpst gr
262
263
264 _cdiff-prep() {
265 # join options which are continued to multiples lines onto one line
266 local first=true
267 grep -vE '^([ \t]*#|^[ \t]*$)' "$1" | while IFS= read -r line; do
268 # remove leading spaces/tabs. assumes extglob
269 if [[ $line == "[ ]*" ]]; then
270 line="${line##+( )}"
271 fi
272 if $first; then
273 pastline="$line"
274 first=false
275 elif [[ $line == *=* ]]; then
276 echo "$pastline" >> "$2"
277 pastline="$line"
278 else
279 pastline="$pastline $line"
280 fi
281 done
282 echo "$pastline" >> "$2"
283 }
284
285 _khfix_common() {
286 local host=${1##*@}
287 local ip port
288 read -r ip port < <(timeout 1 ssh -oBatchMode=yes -oControlMaster=no -oControlPath=/ -v $1 |& sed -rn "s/debug1: Connecting to $host \[([^\]*)] port ([0-9]+).*/\1 \2/p")
289 if [[ ! $ip ]]; then
290 echo "khfix: ssh failed"
291 return 1
292 fi
293 if [[ $port != 22 ]]; then
294 ip_entry="[$ip]:$port"
295 host_entry="[$host]:$port"
296 else
297 ip_entry=$ip
298 host_entry=$host
299 fi
300 ssh-keygen -R "$host_entry" -f $(readlink -f ~/.ssh/known_hosts)
301 echo "khfix: removing key for $ip_entry"
302 ssh-keygen -R "$ip_entry" -f $(readlink -f ~/.ssh/known_hosts)
303 }
304 khfix() { # known hosts fix
305 _khfix_common "$@" || return 1
306 ssh $1 :
307 }
308 khcopy() {
309 _khfix_common "$@"
310 ssh-copy-id $1
311 }
312
313 a() {
314 local x=$(readlink -nf "$@")
315 # yes, its kinda dumb that xclip/xsel cant do this in one invocation
316 echo -n "$x" | xclip -selection clipboard
317 echo -n "$x" | xclip
318 }
319
320 ack() { ack-grep "$@"; }
321
322 anki() {
323 if which anki &>/dev/null; then
324 command anki
325 else
326 schroot -c anki -- anki
327 fi
328 }
329
330 astudio() {
331 # googling android emulator libGL error: failed to load driver: r600
332 # lead to http://stackoverflow.com/a/36625175/14456
333 export ANDROID_EMULATOR_USE_SYSTEM_LIBS=1
334 /a/opt/android-studio/bin/studio.sh "$@" &r;
335 }
336
337 b() {
338 # backwards
339 c -
340 }
341
342 bbk() {
343 # run latest
344 install-my-scripts
345 btrbk-run "$@"
346 }
347
348 bfg() { java -jar /a/opt/bfg-1.12.14.jar "$@"; }
349
350 bigclock() {
351 xclock -digital -update 1 -face 'arial black-80:bold'
352 }
353
354 bpush() {
355 case $HOSTNAME in
356 tp) target=x2 ;;
357 x2) target=tp ;;
358 esac
359 btrbk-run -t $target && switch-mail-host $HOSTNAME $target
360 }
361 bpull() {
362 case $HOSTNAME in
363 tp) source=x2 ;;
364 x2) source=tp ;;
365 esac
366 btrbk-run -s $source && switch-mail-host $source $HOSTNAME
367 }
368
369 btc() {
370 local f=/etc/bitcoin/bitcoin.conf
371 # importprivkey will timeout if using the default of 15 mins.
372 # upped it to 1 hour.
373 bitcoin-cli -rpcclienttimeout=60000 -$(s grep rpcuser= $f) -$(s grep rpcpassword= $f) "$@"
374 }
375
376 btcusd() { # $1 btc in usd
377 local price
378 price="$(curl -s https://api.coinbase.com/v2/prices/BTC-USD/spot | jq -r .data.amount)"
379 printf "$%s\n" "$price"
380 if [[ $1 ]]; then
381 printf "$%.2f\n" "$(echo "scale=4; $price * $1"| bc -l)"
382 fi
383 }
384 usdbtc() { # $1 usd in btc
385 local price
386 price="$(curl -s https://api.coinbase.com/v2/prices/BTC-USD/spot | jq -r .data.amount)"
387 printf "$%s\n" "$price"
388 if [[ $1 ]]; then
389 # 100 mil satoshi / btc. 8 digits after the 1.
390 printf "%.8f btc\n" "$(echo "scale=10; $1 / $price "| bc -l)"
391 fi
392 }
393 satoshi() { # $1 satoshi in usd
394 local price
395 price="$(curl -s https://api.coinbase.com/v2/prices/BTC-USD/spot | jq -r .data.amount)"
396 price=$(echo "scale=10; $price * 0.00000001"| bc -l)
397 printf "$%f\n" "$price"
398 if [[ $1 ]]; then
399 printf "$%.2f\n" "$(echo "scale=10; $price * $1"| bc -l)"
400 fi
401 }
402
403
404 # c. better cd
405 if [[ $RLC_INSIDE_EMACS ]]; then
406 c() { wcd -c -z 50 -o "$@"; }
407 else
408 # lets see what the fancy terminal does from time to time
409 c() { wcd -c -z 50 "$@"; }
410 fi
411
412 caa() { git commit --amend --no-edit -a; }
413
414 caf() {
415 find -L $1 -type f -not \( -name .svn -prune -o -name .git -prune \
416 -o -name .hg -prune -o -name .editor-backups -prune \
417 -o -name .undo-tree-history -prune \) \
418 -exec bash -lc 'hr; echo "$1"; hr; cat "$1"' _ {} \; 2>/dev/null
419
420 }
421
422 calc() { echo "scale=3; $*" | bc -l; }
423 # no having to type quotes, but also no command history:
424 clc() {
425 local x
426 read -r x
427 echo "scale=3; $x" | bc -l
428 }
429
430 cam() {
431 git commit -am "$*"
432 }
433
434 cbfstool () { /a/opt/coreboot/build/cbfstool "$@"; }
435
436 ccat () { # config cat. see a config without extra lines.
437 grep '^\s*[^;[:space:]#]' "$@"
438 }
439
440 cdiff() {
441 # diff config files,
442 # setup for format of postfix, eg:
443 # option = stuff[,]
444 # [more stuff]
445 local pastline
446 local unified="$(mktemp)"
447 local f1="$(mktemp)"
448 local f2="$(mktemp)"
449 _cdiff-prep "$1" "$f1"
450 _cdiff-prep "$2" "$f2"
451 cat "$f1" "$f2" | grep -Po '^[^=]+=' | sort | uniq > "$unified"
452 while IFS= read -r line; do
453 # the default bright red / blue doesnt work in emacs shell
454 dwdiff -cblue,red -A best -d " ," <(grep "^$line" "$f1" || echo ) <(grep "^$line" "$f2" || echo ) | colordiff
455 done < "$unified"
456 }
457
458 cgpl()
459 {
460 if (($#)); then
461 cp /a/bin/data/COPYING "$@"
462 else
463 cp /a/bin/data/COPYING .
464 fi
465 }
466
467 capache()
468 {
469 if (($#)); then
470 cp /a/bin/data/LICENSE "$@"
471 else
472 cp /a/bin/data/LICENSE .
473 fi
474 }
475
476 cat-new-files() {
477 local start=$SECONDS
478 local dir="$1"
479 inotifywait -m "$dir" -e create -e moved_to |
480 while read filedir _ file; do
481 cat "$filedir$file"
482 hr
483 calc $((SECONDS - start)) / 60
484 sleep 5
485 done
486
487 }
488
489 chown() {
490 # makes it so chown -R symlink affects the symlink and its target.
491 if [[ $1 == -R ]]; then
492 shift
493 command chown -h "$@"
494 command chown -R "$@"
495 else
496 command chown "$@"
497 fi
498 }
499
500 cim() {
501 git commit -m "$*"
502 }
503
504 cl() {
505 # choose recent directory. cl = cd list
506 c =
507 }
508
509 chrome() {
510 if type -p chromium &>/dev/null; then
511 cmd=chromium
512 else
513 cd
514 cmd="schroot -c stretch chromium"
515 CHROMIUM_FLAGS='--enable-remote-extensions' $cmd &r
516 fi
517 }
518
519 d() { builtin bg; }
520 complete -A stopped -P '"%' -S '"' d
521
522 dat() { # do all tee, for more complex scripts
523 tee >(ssh frodo bash -l) >(bash -l) >(ssh x2 bash -l) >(ssh tp bash -l)
524 }
525 da() { # do all
526 local host
527 "$@"
528 for host in x2 tp kd; do
529 ssh $host "$@"
530 done
531 }
532
533 dc() {
534 diff --strip-trailing-cr -w "$@" # diff content
535 }
536
537 debian_pick_mirror () {
538 # netselect-apt finds a fast mirror.
539 # but we need to replace the mirrors ourselves,
540 # because it doesnt do that. best it can do is
541 # output a basic sources file
542 # here we get the server it found, get the main server we use
543 # then substitute all instances of one for the other in the sources file
544 # and backup original to /etc/apt/sources.list-original.
545 # this is idempotent. the only way to identify debian sources is to
546 # note the original server, so we put it in a comment so we can
547 # identify it later.
548 local file=$(mktemp -d)/f # safe way to get file name without creating one
549 sudo netselect-apt -o "$file" || return 1
550 url=$(grep ^\\w $file | head -n1 | awk '{print $2}')
551 sudo cp -f /etc/apt/sources.list /etc/apt/sources.list-original
552 sudo sed -ri "/http.us.debian.org/ s@( *[^ #]+ +)[^ ]+([^#]+).*@\1$url\2# http.us.debian.org@" /etc/apt/sources.list
553 sudo apt-get update
554 }
555
556 despace() {
557 local x y
558 for x in "$@"; do
559 y="${x// /_}"
560 safe_rename "$x" "$y"
561 done
562 }
563
564 dt() {
565 date "+%A, %B %d, %r" "$@"
566 }
567
568 dus() { # du, sorted, default arg of
569 du -sh ${@:-*} | sort -h
570 }
571
572
573
574 e() { echo "$@"; }
575
576
577 ediff() {
578 [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
579 emacs --eval "(ediff-files \"$1\" \"$2\")"
580 }
581
582
583 envload() { # load environment from a previous: export > file
584 local file=${1:-$HOME/.${USER}_env}
585 eval "$(export | sed 's/^declare -x/export -n/')"
586 while IFS= read -r line; do
587 # declare -x makes variables local to a function
588 eval ${line/#declare -x/export}
589 done < "$file"
590 }
591
592 # mail related
593 etail() {
594 sudo tail -f /var/log/exim4/mainlog
595 }
596
597 f() {
598 # cd forward
599 c +
600 }
601
602 fa() {
603 # find array. make an array of file names found by find into $x
604 # argument: find arguments
605 # return: find results in an array $x
606 while read -rd ''; do
607 x+=("$REPLY");
608 done < <(find "$@" -print0);
609 }
610
611 faf() { # find all files
612 find -L $1 -not \( -name .svn -prune -o -name .git -prune \
613 -o -name .hg -prune -o -name .editor-backups -prune \
614 -o -name .undo-tree-history -prune \) 2>/dev/null
615 }
616
617 # one that comes with distros is too old for newer devices
618 fastboot() {
619 /a/opt/android-platform-tools/fastboot "$@";
620 }
621
622 kdecd() { /usr/lib/x86_64-linux-gnu/libexec/kdeconnectd; }
623
624 # List of apps to install/update
625 # Create from existing manually installed apps by doing
626 # fdroidcl update
627 # fdroidcl search -i, then manually removing
628 # automatically installed/preinstalled apps
629
630 #
631 # # my attempt at recovering from boot loop:
632 # # in that case, boot to recovery (volume up, home button, power, let go of power after samsun logo)
633 # # then
634 # mount /dev/block/mmcblk0p12 /data
635 # cd /data
636 # find -iname '*appname*'
637 # rm -rf FOUND_DIRS
638 # usually good enough to just rm -rf /data/app/APPNAME
639 #
640 # currently broken:
641 # # causes replicant to crash
642 # org.quantumbadger.redreader
643 # org.kde.kdeconnect_tp
644
645 # not broke, but wont work without gps
646 #com.zoffcc.applications.zanavi
647 # not broke, but not using atm
648 #com.nutomic.syncthingandroid
649 # # doesn\'t work on replicant
650 #net.sourceforge.opencamera
651 #
652 fdroid_pkgs=(
653 de.marmaro.krt.ffupdater
654 me.ccrama.redditslide
655 org.fedorahosted.freeotp
656 at.bitfire.davdroid
657 com.alaskalinuxuser.justnotes
658 com.artifex.mupdf.viewer.app
659 com.danielkim.soundrecorder
660 com.fsck.k9
661 com.ghostsq.commander
662 com.ichi2.anki
663 com.jmstudios.redmoon
664 com.jmstudios.chibe
665 org.kde.kdeconnect_tp
666 com.notecryptpro
667 com.termux
668 cz.martykan.forecastie
669 de.danoeh.antennapod
670 de.blinkt.openvpn
671 de.marmaro.krt.ffupdater
672 eu.siacs.conversations
673 free.rm.skytube.oss
674 im.vector.alpha # riot
675 info.papdt.blackblub
676 me.tripsit.tripmobile
677 net.gaast.giggity
678 net.minetest.minetest
679 net.osmand.plus
680 org.isoron.uhabits
681 org.linphone
682 org.gnu.icecat
683 org.smssecure.smssecure
684 org.yaaic
685 sh.ftp.rocketninelabs.meditationassistant.opensource
686 )
687 # https://forum.xda-developers.com/android/software-hacking/wip-selinux-capable-superuser-t3216394
688 # for maru,
689 #me.phh.superuser
690
691 fdup() {
692 local -A installed updated
693 local p
694 fdroidcl update
695 if fdroidcl search -u | grep ^org.fdroid.fdroid; then
696 fdroidcl upgrade org.fdroid.fdroid
697 sleep 5
698 fdroidcl update
699 fi
700 for p in $(fdroidcl search -i| grep -o "^\S\+"); do
701 installed[$p]=true
702 done
703 for p in $(fdroidcl search -u| grep -o "^\S\+"); do
704 updated[$p]=false
705 done
706 for p in ${fdroid_pkgs[@]}; do
707 if ! ${installed[$p]:-false}; then
708 fdroidcl install $p
709 # sleeps are just me being paranoid since replicant has a history of crashing when certain apps are installed
710 sleep 5
711 fi
712 done
713 for p in ${!installed[@]}; do
714 if ! ${updated[$p]:-true}; then
715 fdroidcl upgrade $p
716 sleep 5
717 fi
718 done
719 }
720
721 firefox-default-profile() {
722 key=Default value=1 section=$1
723 file=/p/c/subdir_files/.mozilla/firefox/profiles.ini
724 sed -ri "/^ *$key/d" "$file"
725 sed -ri "/ *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d};/ *\[$section\]/a $key=$value" "$file"
726 }
727 fdhome() { #firefox default home profile
728 firefox-default-profile Profile0
729 }
730
731 fdwork() {
732 firefox-default-profile Profile4
733 }
734
735 ff() {
736 if type -P firefox &>/dev/null; then
737 firefox "$@"
738 else
739 iceweasel "$@"
740 fi
741 }
742
743
744
745 fn() {
746 firefox -P alt "$@" >/dev/null 2>&1
747 }
748
749
750 fsdiff () {
751 local missing=false
752 local dname="${PWD##*/}"
753 local m="/a/tmp/$dname-missing"
754 local d="/a/tmp/$dname-diff"
755 [[ -e $d ]] && rm "$d"
756 [[ -e $m ]] && rm "$m"
757 local msize=0
758 local fsfile
759 while read -r line; do
760 fsfile="$1${line#.}"
761 if [[ -e "$fsfile" ]]; then
762 md5diff "$line" "$fsfile" && tee -a "/a/tmp/$dname-diff" <<< "$fsfile $line"
763 else
764 missing=true
765 echo "$line" >> "$m"
766 msize=$((msize + 1))
767 fi
768 done < <(find -type f )
769 if $missing; then
770 echo "$m"
771 (( msize <= 100 )) && cat $m
772 fi
773 }
774 fsdiff-test() {
775 # expected output, with different tmp dirs
776 # /tmp/tmp.HDPbwMqdC9/c/d ./c/d
777 # /a/tmp/tmp.qLDkYxBYPM-missing
778 # ./b
779 cd $(mktemp -d)
780 echo ok > a
781 echo nok > b
782 mkdir c
783 echo ok > c/d
784 local x=$(mktemp -d)
785 mkdir $x/c
786 echo different > $x/c/d
787 echo ok > $x/a
788 fsdiff $x
789 }
790 rename-test() {
791 # test whether missing files were renamed, generally for use with fsdiff
792 # $1 = fsdiff output file, $2 = directory to compare to. pwd = fsdiff dir
793 # echos non-renamed files
794 local x y found
795 unset sums
796 for x in "$2"/*; do
797 { sums+=( "$(md5sum < "$x")" ) ; } 2>/dev/null
798 done
799 while read -r line; do
800 { missing_sum=$(md5sum < "$line") ; } 2>/dev/null
801 renamed=false
802 for x in "${sums[@]}"; do
803 if [[ $missing_sum == "$x" ]]; then
804 renamed=true
805 break
806 fi
807 done
808 $renamed || echo "$line"
809 done < "$1"
810 return 0
811 }
812
813 feh() {
814 # F = fullscren, z = random, Z = auto zoom
815 command feh -FzZ "$@"
816 }
817
818 # mail related
819 frozen() {
820 rm -rf /tmp/frozen
821 s mailq |gr frozen|awk '{print $3}' | while read -r id; do
822 s exim -Mvl $id
823 echo
824 s exim -Mvh $id
825 echo
826 s exim -Mvb $id
827 echo -e '\n\n##############################\n'
828 done | tee -a /tmp/frozen
829 }
830 frozenrm() {
831 local ids=()
832 while read -r line; do
833 printf '%s\n' "$line"
834 ids+=($(printf '%s\n' "$line" |gr frozen|awk '{print $3}'))
835 done < <(s mailq)
836 echo "sleeping for 2 in case you change your mind"
837 sleep 2
838 s exim -Mrm "${ids[@]}"
839 }
840
841 funce() {
842 # like -e for functions. returns on error.
843 # at the end of the function, disable with:
844 # trap ERR
845 trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
846 ${FUNCNAME:+FUNCNAME=\"$FUNCNAME\" }${LINENO:+LINENO=\"$LINENO\" }\$?=$?"
847 trap ERR
848 return' ERR
849 }
850
851
852 fw() {
853 firefox -P default "$@" >/dev/null 2>&1
854 }
855
856 getdir () {
857 local help="Usage: getdir [--help] PATH
858 Output the directory of PATH, or just PATH if it is a directory."
859 if [[ $1 == --help ]]; then
860 echo "$help"
861 return 0
862 fi
863 if [[ $# -ne 1 ]]; then
864 echo "getdir error: expected 1 argument, got $#"
865 return 1
866 fi
867 if [[ -d $1 ]]; then
868 echo "$1"
869 else
870 local dir="$(dirname "$1")"
871 if [[ -d $dir ]]; then
872 echo "$dir"
873 else
874 echo "getdir error: directory does not exist"
875 return 1
876 fi
877 fi
878 }
879
880 git_empty_branch() { # start an empty git branch. carefull, it deletes untracked files.
881 [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
882 local gitroot
883 gitroot || return 1 # function to set gitroot
884 builtin cd "$gitroot"
885 git symbolic-ref HEAD refs/heads/$1
886 rm .git/index
887 git clean -fdx
888 }
889
890 gitroot() {
891 local help="Usage: gitroot [--help]
892 Print the full path to the root of the current git repo
893
894 Handles being within a .git directory, unlike git rev-parse --show-toplevel,
895 and works in older versions of git which did not have that."
896 if [[ $1 == --help ]]; then
897 echo "$help"
898 return
899 fi
900 local p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
901 [[ $p != /* ]] && p=$PWD
902 echo "${p%%/.git}"
903 }
904
905 gitian() {
906 git config user.email ian@iankelling.org
907 }
908
909 gh() {
910 # i got an error, gh not found when doing a pull request, it seems like it wants itself in it\'s path.
911 local _oldpath="$PATH"
912 PATH="$PATH:~/node_modules/.bin"
913 command gh "$@"
914 PATH="$_oldpath"
915 }
916
917 gmacs() {
918 # quit will prompt if the program crashes.
919 gdb -ex=r -ex=quit --args emacs "$@"; r;
920 }
921
922 gdkill() {
923 # kill the emacs daemon
924 pk1 emacs --daemon
925 }
926
927 # at least in flidas, things rely on gpg being gpg1
928 gpg() {
929 command gpg2 "$@"
930 }
931
932 gse() {
933 git send-email --notes '--envelope-sender=<ian@iankelling.org>' \
934 --suppress-cc=self "$@"
935 }
936
937 gr() {
938 grep -iIP --color=auto "$@"
939 }
940
941 grr() { # grep recursive
942 if [[ ${#@} == 1 ]]; then
943 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -RiIP --color=auto "$@" .
944 else
945 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -RiIP --color=auto "$@"
946 fi
947 }
948
949 hstatus() {
950 # do git status on published repos
951 cd /a/bin/githtml
952 do_hr=false
953 for x in *; do
954 cd `readlink -f $x`/..
955 status=$(i status -s) || pwd
956 if [[ $status ]]; then
957 hr
958 echo $x
959 printf "%s\n" "$status"
960 fi
961 cd /a/bin/githtml
962 done
963 }
964
965 hl() { # history limit. Write extra history to archive file.
966 # todo: this is not working or not used currently
967 local max_lines linecount tempfile prune_lines x
968 local harchive="${HISTFILE}_archive"
969 for x in "$HISTFILE" "$harchive"; do
970 [[ -e $x ]] || { touch "$x" && echo "notice from hl(): creating $x"; }
971 if [[ ! $x || ! -e $x || ! -w $x || $(stat -c "%u" "$x") != $EUID ]]; then
972 echo "error in hl: history file \$x:$x no good"
973 return 1
974 fi
975 done
976 history -a # save history
977 max_lines=$HISTFILELINES
978 [[ $max_lines =~ ^[0-9]+$ ]] || { echo "error in hl: failed to get max line count"; return 1; }
979 linecount=$(wc -l < $HISTFILE) # pipe so it doesnt output a filename
980 [[ $linecount =~ ^[0-9]+$ ]] || { echo "error in hl: wc failed"; return 1; }
981 if (($linecount > $max_lines)); then
982 prune_lines=$(($linecount - $max_lines))
983 head -n $prune_lines "$HISTFILE" >> "$harchive" \
984 && sed --follow-symlinks -ie "1,${prune_lines}d" $HISTFILE
985 fi
986 }
987
988 hr() { # horizontal row. used to break up output
989 printf "$(tput setaf 5)â–ˆ$(tput sgr0)%.0s" $(seq ${COLUMNS:-60})
990 echo
991 }
992
993 hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; done }
994
995 # get latest hub and run it
996 # main command to use:
997 # hub pull-request --no-edit
998 # --no-edit means to use the first commit\'s message as the pull request message.
999 # Also, you need to use a feature branch, not master in your fork.
1000 # On first use, you input username/pass and it gets an oath token so you dont have to repeat
1001 # it\'s at ~/.config/hub
1002 hub() {
1003 local up uptar updir p
1004 p=/github/hub/releases/
1005 up=https://github.com/$(curl -s https://github.com$p| grep -o $p'download/[^/]*/hub-linux-amd64[^"]*' | head -n1)
1006 uptar=${up##*/}
1007 updir=${uptar%.tgz}
1008 if [[ ! -e /a/opt/$updir ]]; then
1009 rm -rf /a/opt/hub-linux-amd64*
1010 wget -P /a/opt $up
1011 tar -C /a/opt -zxf /a/opt/$uptar
1012 rm -f /a/opt/$uptar
1013 s /a/opt/$updir/install
1014 fi
1015
1016 # save token across computers
1017 if [[ ! -L ~/.config/hub ]]; then
1018 if [[ -e ~/.config/hub ]]; then
1019 mv ~/.config/hub /p/c/subdir_files/.config/
1020 fi
1021 if [[ -e /p/c/subdir_files/.config/hub ]]; then
1022 conflink
1023 fi
1024 fi
1025 command hub "$@"
1026 }
1027
1028 i() { git "$@"; }
1029 # modified from ~/local/bin/git-completion.bash
1030 # other completion commands are mostly taken from bash_completion package
1031 complete -o bashdefault -o default -o nospace -F _git i 2>/dev/null \
1032 || complete -o default -o nospace -F _git i
1033
1034 if ! type service &>/dev/null; then
1035 service() {
1036 echo actually running: systemctl $2 $1
1037 systemctl $2 $1
1038 }
1039 fi
1040
1041 ic() {
1042 # fast commit all
1043 git commit -am "$*"
1044 }
1045
1046
1047 idea() {
1048 /a/opt/idea-IC-163.7743.44/bin/idea.sh "$@" &r
1049 }
1050
1051 ifn() {
1052 # insensitive find
1053 find -L . -not \( -name .svn -prune -o -name .git -prune \
1054 -o -name .hg -prune -o -name .editor-backups -prune \
1055 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1056 }
1057
1058
1059 if [[ $OS == Windows_NT ]]; then
1060 # cygstart wrapper
1061 cs() {
1062 cygstart "$@" &
1063 }
1064 xp() {
1065 explorer.exe .
1066 }
1067 # launch
1068 o() {
1069 local x=(*$1*)
1070 (( ${#x[#]} > 1 )) && { echo "warning ${#x[#]} matches found"; sleep 1; }
1071 cygstart *$1* &
1072 }
1073 else
1074 o() {
1075 if type gvfs-open &> /dev/null ; then
1076 gvfs-open "$@"
1077 else
1078 xdg-open "$@"
1079 fi
1080 # another alternative is run-mailcap
1081 }
1082 fi
1083
1084 ipdrop() {
1085 s iptables -A INPUT -s $1 -j DROP
1086 }
1087
1088 net-dev-info() {
1089 e "lspci -nnk|gr -iA2 net"
1090 lspci -nnk|gr -iA2 net
1091 hr
1092 e "s lshw -C network"
1093 hr
1094 s lshw -C network
1095
1096 }
1097
1098 istext() {
1099 grep -Il "" "$@" &>/dev/null
1100 }
1101
1102 jtail() {
1103 journalctl -n 10000 -f "$@" | grep -Evi "^(\S+\s+){4}(sudo|sshd|cron)"
1104 }
1105
1106 kff() { # keyboardio firmware flash
1107 pushd /a/bin/distro-setup/Arduino/Model01-Firmware
1108 yes $'\n' | make flash
1109 popd
1110 }
1111
1112 l() {
1113 if [[ $PWD == /[iap] ]]; then
1114 command ls -A --color=auto -I lost+found "$@"
1115 else
1116 command ls -A --color=auto "$@"
1117 fi
1118 }
1119
1120
1121 lcn() { locate -i "*$**"; }
1122
1123 lg() { LC_COLLATE=C.UTF-8 ll --group-directories-first; }
1124
1125 lt() { ll -tr "$@"; }
1126
1127 lld() { ll -d "$@"; }
1128
1129 lom() {
1130 local l base
1131 if [[ $1 == /* ]]; then
1132 base=${1##*/}
1133 if mountpoint /mnt/$base; then
1134 return 0
1135 fi
1136 l=$(sudo losetup -f)
1137 sudo losetup $l $1
1138 if ! sudo cryptsetup luksOpen $l $base; then
1139 sudo losetup -d $l
1140 return 1
1141 fi
1142 sudo mkdir -p /mnt/$base
1143 sudo mount /dev/mapper/$base /mnt/$base
1144 sudo chown $USER:$USER /mnt/$base
1145 else
1146 base=$1
1147 sudo umount /mnt/$base
1148 l=$(sudo cryptsetup status /dev/mapper/$base|sed -rn 's/^\s*device:\s*(.*)/\1/p')
1149 sudo cryptsetup luksClose /dev/mapper/$base || return 1
1150 sudo losetup -d $l
1151 fi
1152 }
1153
1154 low() { # make filenames lowercase, remove bad chars
1155 local f new
1156 for f in "$@"; do
1157 new="${f,,}" # downcase
1158 new="${new//[^[:alnum:]._-]/_}" # sub bad chars
1159 new="${new#"${new%%[[:alnum:]]*}"}" # remove leading/trailing non-alnum
1160 new="${new%"${new##*[[:alnum:]]}"}"
1161 # remove bad underscores, like __ and _._
1162 new=$(echo $new | sed -r 's/__+/_/g;s/_+([.-])|([.-])_+/\1/g')
1163 safe_rename "$f" "$new" || return 1
1164 done
1165 return 0
1166 }
1167
1168 lower() { # make first letter of filenames lowercase.
1169 local x
1170 for x in "$@"; do
1171 if [[ ${x::1} == [A-Z] ]]; then
1172 y=$(tr "[A-Z]" "[a-z]" <<<"${x::1}")"${x:1}"
1173 safe_rename "$x" "$y" || return 1
1174 fi
1175 done
1176 }
1177
1178
1179 k() { # history search
1180 grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | tail -n 80;
1181 }
1182
1183 ks() { # history search
1184 grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | uniq;
1185 }
1186
1187
1188 make-targets() {
1189 # show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
1190 make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
1191 }
1192
1193 mbenable() {
1194 mb=$1
1195 dst=/m/4e/$1
1196 src=/m/md/$1
1197 set -x
1198 [[ -e $src ]] || { set +x; return 1; }
1199 mv -T $src $dst || { set +x; return 1; }
1200 ln -s -T $dst $src
1201 /a/exe/lnf /p/.mu ~
1202 mu index --maildir=/m/4e
1203 set +x
1204 }
1205 mbdisable() {
1206 mb=$1
1207 dst=/m/md/$1
1208 src=/m/4e/$1
1209 set -x
1210 [[ -e $src ]] || { set +x; return 1; }
1211 if [[ -L $dst ]]; then rm $dst; fi
1212 mv -T $src $dst
1213 set +x
1214 }
1215
1216
1217 mdt() {
1218 markdown "$1" >/tmp/mdtest.html
1219 firefox /tmp/mdtest.html
1220 }
1221
1222
1223 mkc() {
1224 mkdir "$1"
1225 c "$1"
1226 }
1227
1228 mkct() {
1229 mkc `mktemp -d`
1230 }
1231
1232 mkt() { # mkdir and touch file
1233 local path="$1"
1234 mkdir -p "$(dirname "$path")"
1235 touch "$path"
1236 }
1237
1238 mkdir() { command mkdir -p "$@"; }
1239
1240 mo() { xset dpms force off; } # monitor off
1241
1242
1243 nopanic() {
1244 sudo tee -a /var/log/exim4/paniclog-archive </var/log/exim4/paniclog; sudo truncate -s0 /var/log/exim4/paniclog
1245 }
1246
1247
1248 otp() {
1249 oathtool --totp -b "$@" | xclip -selection clipboard
1250 }
1251
1252 p8() { ping 8.8.8.8; }
1253
1254 pakaraoke() {
1255 # from http://askubuntu.com/questions/456021/remove-vocals-from-mp3-and-get-only-instrumentals
1256 pactl load-module module-ladspa-sink sink_name=Karaoke master=alsa_output.usb-Audioengine_Audioengine_D1-00.analog-stereo plugin=karaoke_1409 label=karaoke control=-30
1257 }
1258
1259
1260 pfind() { #find *$1* in $PATH
1261 [[ $# != 1 ]] && { echo requires 1 argument; return 1; }
1262 local pathArray
1263 IFS=: pathArray=($PATH); unset IFS
1264 find "${pathArray[@]}" -iname "*$1*"
1265 }
1266
1267 pk1() {
1268 local pid
1269 pid=($(pgrep -f "$*"))
1270 case ${#pid[@]} in
1271 1)
1272 ps -F $pid
1273 m kill $pid
1274 ;;
1275 0) echo "no pid found" ;;
1276 *)
1277 ps -F ${pid[@]}
1278 ;;
1279 esac
1280 }
1281
1282 pick-trash() {
1283 # trash-restore lists everything that has been trashed at or below CWD
1284 # This picks out files just in CWD, not subdirectories,
1285 # which also match grep $1, usually use $1 for a time string
1286 # which you get from running restore-trash once first
1287 local name x ask
1288 local nth=1
1289 # last condition is to not ask again for ones we skipped
1290 while name="$( echo | restore-trash | gr "$PWD/[^/]\+$" | gr "$1" )" \
1291 && [[ $name ]] && (( $(wc -l <<<"$name") >= nth )); do
1292 name="$(echo "$name" | head -n $nth | tail -n 1 )"
1293 read -p "$name [Y/n] " ask
1294 if [[ ! $ask || $ask == [Yy] ]]; then
1295 x=$( echo "$name" | gr -o "^\s*[0-9]*" )
1296 echo $x | restore-trash > /dev/null
1297 elif [[ $ask == [Nn] ]]; then
1298 nth=$((nth+1))
1299 else
1300 return
1301 fi
1302 done
1303 }
1304
1305
1306 pub() {
1307 rld /a/h/_site/ li:/var/www/iankelling.org/html
1308 }
1309
1310 pubip() { curl -4s https://icanhazip.com; }
1311 pubip6() { curl -6s https://icanhazip.com; }
1312 whatismyip() { pubip; }
1313
1314 pumpa() {
1315 # fixes the menu bar in xmonad. this won\'t be needed when xmonad
1316 # packages catches up on some changes in future (this is written in
1317 # 4/2017)
1318 #
1319 # geekosaur: so youll want to upgrade to xmonad 0.13 or else use a
1320 # locally modified XMonad.Hooks.ManageDocks that doesnt set the
1321 # work area; turns out it\'s impossible to set correctly if you are
1322 # not a fully EWMH compliant desktop environment
1323 #
1324 # geekosaur: chrome shows one failure mode, qt/kde another, other
1325 # gtk apps a third, ... I came up with a setting that works for me
1326 # locally but apparently doesnt work for others, so we joined the
1327 # other tiling window managers in giving up on setting it at all
1328 #
1329 xprop -root -remove _NET_WORKAREA
1330 command pumpa &r
1331 }
1332
1333
1334 pwgen() {
1335 # -m = min length
1336 # -x = max length
1337 # -t = print pronunciation
1338 apg -m 14 -x 17 -t
1339 for (( i=0; i<10; i++ )); do
1340 shuf -n3 /usr/share/hunspell/en_US.dic | sed 's,/.*,,' | paste -sd . -
1341
1342 done
1343 }
1344
1345 pwlong() {
1346 # -M CLN = use Caps, Lowercase, Numbers
1347 # -n 1 = 1 password
1348 # -a 1 = use random instead of pronounceable algorithm
1349 apg -m 50 -x 70 -n 1 -a 1 -M CLN
1350 }
1351
1352
1353 q() { # start / launch a program in the backround and redir output to null
1354 "$@" &> /dev/null &
1355 }
1356
1357 r() {
1358 exit "$@" 2>/dev/null
1359 }
1360
1361 rbpipe() { rbt post -o --diff-filename=- "$@"; }
1362 rbp() { rbt post -o "$@"; }
1363
1364 rl() {
1365 # rsync, root is required to keep permissions right.
1366 # rsync --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
1367 # --no-times --delete
1368 # basically, make an exact copy, use checksums instead of file times to be more accurate
1369 rsync -ahvic --delete "$@"
1370 }
1371 rld() {
1372 # like rlu, but dont delete files on the target end which
1373 # do not exist on the original end.
1374 rsync -ahvic "$@"
1375 }
1376 complete -F _rsync -o nospace rld rl rlt
1377
1378 rlt() {
1379 # rl without preserving modification time.
1380 rsync -ahvic --delete --no-t "$@"
1381 }
1382
1383 rlu() { # [OPTS] HOST PATH
1384 # eg. rlu -opts frodo /testpath
1385 # relative paths will expanded with readlink -f.
1386 # useful for selectively sending dirs which have been synced with unison,
1387 # where the path is the same on both hosts.
1388 opts=("${@:1:$#-2}") # 1 to last -2
1389 path="${@:$#}" # last
1390 host="${@:$#-1:1}" # last -1
1391 if [[ $path == .* ]]; then
1392 path=$(readlink -f $path)
1393 fi
1394 # rync here uses checksum instead of time so we dont mess with
1395 # unison relying on time as much. g is for group, same reason
1396 # to keep up with unison.
1397 s rsync -rlpchviog --relative "${opts[@]}" "$path" "root@$host:/";
1398 }
1399
1400 # only run on MAIL_HOST. simpler to keep this on one system.
1401 r2eadd() { # usage: name url
1402 # initial setup of rss2email:
1403 # r2e new r2e@iankelling.org
1404 # that initializes files, and sets default email.
1405 # symlink to the config doesnt work, so I copied it to /p/c
1406 # and then use cli option to specify explicit path.
1407 # Only option changed from default config is to set
1408 # force-from = True
1409 #
1410 # or else for a few feeds, the from address is set by the feed, and
1411 # if I fail delivery, then I send a bounce message to that from
1412 # address, which makes me be a spammer.
1413
1414 r2e add $1 "$2" $1@r2e.iankelling.org
1415 # get up to date and dont send old entries now:
1416 r2e run --no-send $1
1417 }
1418 r2e() { command r2e -d /p/c/rss2email.json -c /p/c/rss2email.cfg "$@"; }
1419
1420 rspicy() { # usage: HOST DOMAIN
1421 # connect to spice vm remote host. use vspicy for local host
1422 local port=$(ssh $1<<EOF
1423 sudo virsh dumpxml $2|grep "<graphics.*type='spice'" | \
1424 sed -rn "s/.*port='([0-9]+).*/\1/p"
1425 EOF
1426 )
1427 if [[ $port ]]; then
1428 spicy -h $1 -p $port
1429 else
1430 echo "error: no port found. check that the domain is running."
1431 fi
1432 }
1433
1434 rmstrips() {
1435 ssh fencepost head -n 300 /gd/gnuorg/EventAndTravelInfo/rms-current-trips.txt | less
1436 }
1437
1438 s() {
1439 # background
1440 # I use a function because otherwise we cant use in a script,
1441 # cant assign to variable.
1442 #
1443 # note: gksudo is recommended for X apps because it does not set the
1444 # home directory to the same, and thus apps writing to ~ fuck things up
1445 # with root owned files.
1446 #
1447 if [[ $EUID != 0 || $1 == -* ]]; then
1448 SUDOD="$PWD" sudo -i "$@"
1449 else
1450 "$@"
1451 fi
1452 }
1453
1454 safe_rename() { # warn and dont rename if file exists.
1455 # mv -n exists, but it\'s silent
1456 if [[ $# != 2 ]]; then
1457 echo safe_rename error: $# args, need 2 >2
1458 return 1
1459 fi
1460 if [[ $1 != $2 ]]; then # yes, we want to silently ignore this
1461 if [[ -e $2 || -L $2 ]]; then
1462 echo "Cannot rename $1 to $2 as it already exists."
1463 else
1464 mv -vi "$1" "$2"
1465 fi
1466 fi
1467 }
1468
1469
1470 sb() { # sudo bash -c
1471 # use sb instead of s is for sudo redirections,
1472 # eg. sb 'echo "ok fine" > /etc/file'
1473 local SUDOD="$PWD"
1474 sudo -i bash -c "$@"
1475 }
1476 complete -F _root_command s sb
1477
1478 scssl() {
1479 # s gem install scss-lint
1480 pushd /a/opt/thoughtbot-guides
1481 git pull --stat
1482 popd
1483 scss-lint -c /a/opt/thoughtbot-guides/style/sass/.scss-lint.yml "$@"
1484 }
1485
1486 ser() {
1487 local s; [[ $EUID != 0 ]] && s=sudo
1488 if type -p systemctl &>/dev/null; then
1489 $s systemctl $1 $2
1490 else
1491 $s service $2 $1
1492 fi
1493 }
1494 # like restart, but do nothing if its not already started
1495 srestart() {
1496 local service=$1
1497 if [[ $(s systemctl --no-pager show -p ActiveState $service ) == ActiveState=active ]]; then
1498 systemctl restart $service
1499 fi
1500 }
1501 serstopnm() {
1502 ser stop NetworkManager
1503 ser stop dnsmasq
1504 s resolvconf -d NetworkManager
1505 ser start dnsmasq
1506 }
1507
1508 setini() { # set a value in a .ini style file
1509 key="$1" value="$2" section="$3" file="$4"
1510 if [[ -s $file ]]; then
1511 sed -ri -f - "$file" <<EOF
1512 # remove existing keys
1513 / *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d}
1514 # add key
1515 /^\s*\[$section\]/a $key=$value
1516 # from section to eof, do nothing
1517 /^\s*\[$section\]/,\$b
1518 # on the last line, if we haven't found section yet, add section and key
1519 \$a [$section]\\
1520 $key=$value
1521 EOF
1522 else
1523 cat >"$file" <<EOF
1524 [$section]
1525 $key=$value
1526 EOF
1527 fi
1528 }
1529
1530 sgo() { # service go
1531 service=$1
1532 ser restart $service || return 1
1533 if type -p systemctl &>/dev/null; then
1534 ser enable $service
1535 fi
1536 }
1537
1538
1539 shellck() {
1540 # 2086 = unquoted $var
1541 # 2046 = unquoted $(cmd)
1542 # i had -x as an arg, but debian testing(stretch) doesn\'t support it
1543 shellcheck -e 2086,2046,2068,2006,2119 "$@"
1544 }
1545
1546 skaraoke() {
1547 local tmp out
1548 in="$1"
1549 out=${2:-${1%.*}.sh}
1550 tmp=$(mktemp -d)
1551 script -t -c "mpv --no-config --no-resume-playback --no-terminal --no-audio-display '$1'" $tmp/typescript 2>$tmp/timing
1552 # todo, the current sleep seems pretty good, but it
1553 # would be nice to have an empirical measurement, or
1554 # some better wait to sync up.
1555 #
1556 # note: --loop-file=no prevents it from hanging if you have that
1557 # set to inf the mpv config.
1558 # --loop=no prevents it from exit code 3 due to stdin if you
1559 # had it set to inf in mpv config.
1560 #
1561 # args go to mpv, for example --volume=80, 50%
1562 cat >$out <<EOFOUTER
1563 #!/bin/bash
1564 trap "trap - TERM && kill 0" INT TERM ERR; set -e
1565 ( sleep .2; scriptreplay <( cat <<'EOF'
1566 $(cat $tmp/timing)
1567 EOF
1568 ) <( cat <<'EOF'
1569 $(cat $tmp/typescript)
1570 EOF
1571 ))&
1572 base64 -d - <<'EOF'| mpv --loop=no --loop-file=no --no-terminal --no-audio-display "\$@" -
1573 $(base64 "$1")
1574 EOF
1575 kill 0
1576 EOFOUTER
1577 rm -r $tmp
1578 chmod +x $out
1579 }
1580
1581 slog() {
1582 # log with script. timing is $1.t and script is $1.s
1583 # -l to save to ~/typescripts/
1584 # -t to add a timestamp to the filenames
1585 local logdir do_stamp arg_base
1586 (( $# >= 1 )) || { echo "arguments wrong"; return 1; }
1587 logdir="/a/dt/"
1588 do_stamp=false
1589 while getopts "lt" option
1590 do
1591 case $option in
1592 l ) arg_base=$logdir ;;
1593 t ) do_stamp=true ;;
1594 esac
1595 done
1596 shift $(($OPTIND - 1))
1597 arg_base+=$1
1598 [[ -e $logdir ]] || mkdir -p $logdir
1599 $do_stamp && arg_base+=$(date +%F.%T%z)
1600 script -t $arg_base.s 2> $arg_base.t
1601 }
1602 splay() { # script replay
1603 #logRoot="$HOME/typescripts/"
1604 #scriptreplay "$logRoot$1.t" "$logRoot$1.s"
1605 scriptreplay "$1.t" "$1.s"
1606 }
1607
1608 smeld() { # usage host1 host2 file
1609 meld <(ssh $1 cat $3) <(ssh $2 cat $3)
1610 }
1611
1612 spd() {
1613 PATH=/usr/local/spdhackfix:$PATH command spd "$@"
1614 }
1615
1616 spend() {
1617 s systemctl suspend
1618 }
1619
1620 sr() {
1621 # sudo redo. be aware, this command may not work right on strange distros or earlier software
1622 if [[ $# == 0 ]]; then
1623 sudo -E bash -c -l "$(history -p '!!')"
1624 else
1625 echo this command redos last history item. no argument is accepted
1626 fi
1627 }
1628
1629 srm () {
1630 # with -ll, less secure but faster.
1631 command srm -ll "$@"
1632 }
1633
1634 srun() {
1635 scp $2 $1:/tmp
1636 ssh $1 /tmp/${2##*/} "${@:2}"
1637 }
1638
1639 sss() { # ssh solo
1640 ssh -oControlMaster=no -oControlPath=/ "$@"
1641 }
1642 ssk() {
1643 local -a opts=()
1644 while [[ $1 == -* ]]; do
1645 opts+=("$1")
1646 shift
1647 done
1648 m pkill -f "^ssh: /tmp/ssh_mux_${USER}_${1#*@}_22_"
1649 m ssh "${opts[@]}" "$@"
1650 }
1651
1652 swap() {
1653 local tmp
1654 tmp=$(mktemp)
1655 mv $1 $tmp
1656 mv $2 $1
1657 mv $tmp $2
1658 }
1659
1660 t() {
1661 local x
1662 local -a args
1663 if type -t trash-put >/dev/null; then
1664 # skip args that dont exist, or else trash-put will have an error
1665 for x in "$@"; do
1666 if [[ -e $x || -L $x ]]; then
1667 args+=("$x")
1668 fi
1669 done
1670 [[ ! ${args[@]} ]] || trash-put "${args[@]}"
1671 else
1672 rm -rf "$@"
1673 fi
1674 }
1675
1676
1677 tclock() {
1678 clear
1679 date +%l:%_M
1680 len=60
1681 # this goes to full width
1682 #len=${1:-$((COLUMNS -7))}
1683 x=1
1684 while true; do
1685 if (( x == len )); then
1686 end=true
1687 d="$(date +%l:%_M) "
1688 else
1689 end=false
1690 d=$(date +%l:%M:%_S)
1691 fi
1692 echo -en "\r"
1693 echo -n "$d"
1694 for ((i=0; i<x; i++)); do
1695 if (( i % 6 )); then
1696 echo -n _
1697 else
1698 echo -n .
1699 fi
1700 done
1701 if $end; then
1702 echo
1703 x=1
1704 else
1705 x=$((x+1))
1706 fi
1707 sleep 5
1708 done
1709 }
1710
1711
1712 te() {
1713 # test existence / exists
1714 local ret=0
1715 for x in "$@"; do
1716 [[ -e "$x" || -L "$x" ]] || ret=1
1717 done
1718 return $ret
1719 }
1720
1721 # mail related
1722 testmail() {
1723 declare -gi _seq; _seq+=1
1724 echo "test body" | m mail -s "test mail from $HOSTNAME, $_seq" "${@:-root@localhost}"
1725 # for testing to send from an external address, you can do for example
1726 # -fian@iank.bid -aFrom:ian@iank.bid web-6fnbs@mail-tester.com
1727 # note in exim, you can retry a deferred message
1728 # s exim -M MSG_ID
1729 # MSG_ID is in /var/log/exim4/mainlog, looks like 1ccdnD-0001nh-EN
1730 }
1731
1732 # to test sieve, use below command. for fsf mail, see fsf-get-mail script.
1733 # make modifications, then copy to live file, use -eW to actually modify mailbox
1734 # cp /p/c/subdir_files/sieve/personal{test,}.sieve; testsievelist -eW INBOX
1735 #
1736 # Another option is to use sieve-test SCRIPT MAIL_FILE. note,
1737 # sieve-test doesnt know about envelopes, Im not sure if sieve-filter does.
1738
1739 # sieve with output filter. arg is mailbox, like INBOX.
1740 # This depends on dovecot conf, notably mail_location in /etc/dovecot/conf.d/10-mail.conf
1741
1742 testsievelist() {
1743 sieve-filter ~/sieve/maintest.sieve "$@" >/tmp/testsieve.log 2> >(tail) && sed -rn '/^Performed actions:/{n;n;p}' /tmp/testsieve.log | sort -u
1744 }
1745
1746
1747 # mail related
1748 # plain sieve
1749 testsieve() {
1750 sieve-filter ~/sieve/main.sieve "$@"
1751 }
1752
1753 # mail related
1754 testexim() {
1755 # testmail above calls sendmail, which is a link to exim/postfix.
1756 # its docs dont say a way of adding an argument
1757 # to sendmail to turn on debug output. We could make a wrapper, but
1758 # that is a pain. Exim debug args are documented here:
1759 # http://www.exim.org/exim-html-current/doc/html/spec_html/ch-the_exim_command_line.html
1760 #
1761 # http://www.exim.org/exim-html-current/doc/html/spec_html/ch-building_and_installing_exim.html
1762 # note, for exim daemon, you can turn on debug options by
1763 # adding -d, etc to COMMONOPTIONS in
1764 # /etc/default/exim4
1765 exim -d -t <<'EOF'
1766 From: ian@iankelling.org
1767 To: root@lists0p.fsf.org
1768 Subject: Testing Exim
1769
1770 This is a test message.
1771 EOF
1772 }
1773
1774 # toggle keyboard
1775 tk() {
1776 # based on
1777 # https://askubuntu.com/questions/160945/is-there-a-way-to-disable-a-laptops-internal-keyboard
1778 id=$(xinput --list --id-only 'AT Translated Set 2 keyboard')
1779 if xinput list | grep -F '∼ AT Translated Set 2 keyboard' &>/dev/null; then
1780 echo enabling keyboard
1781 # find the first slave keyboard number, they are all the same in my output.
1782 # if they werent, worst case we would need to save the slave number somewhere
1783 # when it got disabled.
1784 slave=$(xinput list | sed -n 's/.*slave \+keyboard (\([0-9]*\)).*/\1/p' | head -n1)
1785 xinput reattach $id $slave
1786 else
1787 xinput float $id
1788 fi
1789 }
1790
1791 tm() {
1792 # timer in minutes
1793 # --no-config
1794 (sleep $(calc "$@ * 60") && mpv --no-config --volume 50 /a/bin/data/alarm.mp3) > /dev/null 2>&1 &
1795 }
1796
1797 trg() { transmission-remote-gtk&r; }
1798 trc() {
1799 # example, set global upload limit to 100 kilobytes:
1800 # trc -u 100
1801 TR_AUTH=":$(jq -r .profiles[0].password ~/.config/transmission-remote-gtk/config.json)" transmission-remote transmission.lan -ne "$@"
1802 }
1803
1804
1805 tu() {
1806 local s;
1807 local dir="$(dirname "$1")"
1808 if [[ -e $1 && ! -w $1 || ! -w $(dirname "$1") ]]; then
1809 s=s;
1810 fi
1811 $s teeu "$@"
1812 }
1813
1814 tx() { # toggle set -x, and the prompt so it doesnt spam
1815 if [[ $- == *x* ]]; then
1816 set +x
1817 PROMPT_COMMAND=prompt-command
1818 # disabled due to issue on stretch, running ll we get error. something
1819 # about the DEBUG trap is broken
1820 # if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
1821 # trap 'settitle "$BASH_COMMAND"' DEBUG
1822 # fi
1823 else
1824 # normally, i would just execute these commands in the function.
1825 # however, DEBUG is not inherited, so we need to run it outside a function.
1826 # And we want to run set -x afterwards to avoid spam, so we cram everything
1827 # in here, and then it will run after this function is done.
1828 #PROMPT_COMMAND='trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "; set -x'
1829
1830 unset PROMPT_COMMAND
1831 PS1="\w \$ "
1832 set -x
1833 fi
1834 }
1835
1836 psnetns() {
1837 # show all processes in the network namespace $1.
1838 # blank entries appear to be subprocesses/threads
1839 local x netns
1840 netns=$1
1841 ps -w | head -n 1
1842 s find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
1843 while read l; do
1844 x=$(ps -w --no-headers -p $l);
1845 if [[ $x ]]; then echo "$x"; else echo $l; fi;
1846 done
1847 }
1848
1849 m() { printf "%s\n" "$*"; "$@"; }
1850
1851
1852 vpncmd() {
1853 #m s nsenter -t $(pgrep -f "/usr/sbin/openvpn .* --config /etc/openvpn/.*pia.conf") -n -m "$@"
1854 m s nsenter -t $(pgrep -f "/usr/sbin/openvpn .* --config /etc/openvpn/.*client.conf") -n -m "$@"
1855 }
1856 vpnf() {
1857 vpncmd gksudo -u iank "firefox -no-remote -P vpn" &r
1858 }
1859 vpni() {
1860 vpncmd gksudo -u iank "$*"
1861 }
1862 vpnbash() {
1863 vpncmd bash
1864 }
1865
1866
1867
1868 virshrm() {
1869 for x in "$@"; do virsh destroy "$x"; virsh undefine "$x"; done
1870 }
1871
1872 vm-set-listen(){
1873 local t=$(mktemp)
1874 local vm=$1
1875 local ip=$2
1876 s virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
1877 sed -r "s/listen='[^']+/listen='$ip/"> $t
1878 s virsh undefine $vm
1879 s virsh define $t
1880 }
1881
1882
1883 vmshare() {
1884 vm-set-listen $1 0.0.0.0
1885 }
1886
1887
1888 vmunshare() {
1889 vm-set-listen $1 127.0.0.1
1890 }
1891
1892
1893 vpn() {
1894 if [[ -e /lib/systemd/system/openvpn-client@.service ]]; then
1895 local vpn_service=openvpn-client
1896 else
1897 local vpn_service=openvpn
1898 fi
1899
1900 [[ $1 ]] || { echo need arg; return 1; }
1901 journalctl --unit=$vpn_service@$1 -f -n0 &
1902 s systemctl start $vpn_service@$1
1903 # sometimes the ask-password agent does not work and needs a delay.
1904 sleep .5
1905 # https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=779240
1906 # noticed around 8-2017 after update from around stretch release
1907 # on debian testing, even though the bug is much older.
1908 s systemd-tty-ask-password-agent
1909 }
1910
1911 vpnoff() {
1912 [[ $1 ]] || { echo need arg; return 1; }
1913 if [[ -e /lib/systemd/system/openvpn-client@.service ]]; then
1914 local vpn_service=openvpn-client
1915 else
1916 local vpn_service=openvpn
1917 fi
1918 s systemctl stop $vpn_service@$1
1919 }
1920
1921
1922 vrm() {
1923 virsh destroy $1
1924 virsh undefine $1
1925 }
1926
1927
1928
1929 vspicy() { # usage: VIRSH_DOMAIN
1930 # connect to vms made with virt-install
1931 spicy -p $(sudo virsh dumpxml "$1"|grep "<graphics.*type='spice'"|\
1932 sed -r "s/.*port='([0-9]+).*/\1/")
1933 }
1934
1935 wian() {
1936 cat-new-files /m/4e/INBOX/new
1937 }
1938
1939 wtr() { curl wttr.in/boston; }
1940
1941 xl() {
1942 if pgrep gnome-screensav &>/dev/null; then
1943 # this command actually starts gnome-screensaver if it isn\'t running.
1944 # lololol, what crap
1945 gnome-screensaver-command --exit &>/dev/null
1946 fi
1947 mate-screensaver-command --exit &>/dev/null
1948 if ! pidof xscreensaver; then
1949 pushd /
1950 xscreensaver &
1951 popd
1952 # 1 was not long enough
1953 sleep 3
1954 fi
1955 xscreensaver-command -activate
1956 }
1957
1958 # * misc stuff
1959
1960 # from curl cheat.sh/:bash_completion
1961 _cheatsh_complete_curl()
1962 {
1963 local cur prev opts
1964 _get_comp_words_by_ref -n : cur
1965
1966 COMPREPLY=()
1967 #cur="${COMP_WORDS[COMP_CWORD]}"
1968 prev="${COMP_WORDS[COMP_CWORD-1]}"
1969 opts="$(curl -s cheat.sh/:list | sed s@^@cheat.sh/@)"
1970
1971 if [[ ${cur} == cheat.sh/* ]] ; then
1972 COMPREPLY=( $(compgen -W "${opts}" -- ${cur}) )
1973 __ltrim_colon_completions "$cur"
1974 return 0
1975 fi
1976 }
1977 complete -F _cheatsh_complete_curl curl
1978
1979
1980 if [[ $- == *i* ]]; then
1981 # commands to run when bash exits normally
1982 trap "hl" EXIT
1983 fi
1984
1985
1986 # temporary variables to test colorization
1987 # some copied from gentoo /etc/bash/bashrc,
1988 use_color=false
1989 # dircolors --print-database uses its own built-in database
1990 # instead of using /etc/DIR_COLORS. Try to use the external file
1991 # first to take advantage of user additions.
1992 safe_term=${TERM//[^[:alnum:]]/?} # sanitize TERM
1993 match_lhs=""
1994 [[ -f ~/.dir_colors ]] && match_lhs="${match_lhs}$(<~/.dir_colors)"
1995 [[ -f /etc/DIR_COLORS ]] && match_lhs="${match_lhs}$(</etc/DIR_COLORS)"
1996 [[ -z ${match_lhs} ]] \
1997 && type -P dircolors >/dev/null \
1998 && match_lhs=$(dircolors --print-database)
1999 # test if our $TERM is in the TERM values in dircolor
2000 [[ $'\n'${match_lhs} == *$'\n'"TERM "${safe_term}* ]] && use_color=true
2001
2002
2003 if ${use_color} && [[ $- == *i* ]]; then
2004
2005 if [[ $XTERM_VERSION == Cygwin* ]]; then
2006 get_term_color() {
2007 for x in "$@"; do
2008 case $x in
2009 underl) echo -n $'\E[4m' ;;
2010 bold) echo -n $'\E[1m' ;;
2011 red) echo -n $'\E[31m' ;;
2012 green) echo -n $'\E[32m' ;;
2013 blue) echo -n $'\E[34m' ;;
2014 cyan) echo -n $'\E[36m' ;;
2015 yellow) echo -n $'\E[33m' ;;
2016 purple) echo -n $'\E[35m' ;;
2017 nocolor) echo -n $'\E(B\E[m' ;;
2018 esac
2019 done
2020 }
2021
2022 else
2023 get_term_color() {
2024 for x in "$@"; do
2025 case $x in
2026 underl) echo -n $(tput smul) ;;
2027 bold) echo -n $(tput bold) ;;
2028 red) echo -n $(tput setaf 1) ;;
2029 green) echo -n $(tput setaf 2) ;;
2030 blue) echo -n $(tput setaf 4) ;;
2031 cyan) echo -n $(tput setaf 6) ;;
2032 yellow) echo -n $(tput setaf 3) ;;
2033 purple) echo -n $(tput setaf 5) ;;
2034 nocolor) echo -n $(tput sgr0) ;; # no font attributes
2035 esac
2036 done
2037 }
2038 fi
2039 else
2040 get_term_color() {
2041 :
2042 }
2043 fi
2044 # Try to keep environment pollution down, EPA loves us.
2045 unset safe_term match_lhs use_color
2046
2047
2048
2049 # * prompt
2050
2051
2052 if [[ $- == *i* ]]; then
2053 # git branch/status prompt function
2054 if [[ $OS != Windows_NT ]]; then
2055 GIT_PS1_SHOWDIRTYSTATE=true
2056 fi
2057 # arch source lopip show -fcation
2058 [[ -r /usr/share/git/git-prompt.sh ]] && source /usr/share/git/git-prompt.sh
2059 # fedora/debian source
2060 [[ -r /usr/share/git-core/contrib/completion/git-prompt.sh ]] && source /usr/share/git-core/contrib/completion/git-prompt.sh
2061
2062 # in case we didnt source git-prompt.sh
2063 if ! declare -f __git_ps1 > /dev/null; then
2064 __git_ps1() {
2065 :
2066 }
2067 fi
2068
2069 # this needs to come before next ps1 stuff
2070 # this stuff needs bash 4, feb 2009,
2071 # old enough to no longer condition on $BASH_VERSION anymore
2072 shopt -s autocd
2073 shopt -s dirspell
2074 PS1='\w'
2075 if [[ $- == *i* ]] && [[ ! $RLC_INSIDE_EMACS ]]; then
2076 PROMPT_DIRTRIM=2
2077 bind -m vi-command B:shell-backward-word
2078 bind -m vi-command W:shell-forward-word
2079 fi
2080
2081 if [[ $SSH_CLIENT ]]; then
2082 PS1="\h $PS1"
2083 fi
2084
2085
2086
2087
2088 prompt-command() {
2089 local return=$? # this MUST COME FIRST
2090 local psc pst ps_char ps_color stale_subvol
2091 unset IFS
2092 history -a # save history
2093
2094
2095
2096 case $return in
2097 0) ps_color="$(get_term_color blue)"
2098 ps_char='\$'
2099 ;;
2100 1) ps_color="$(get_term_color green)"
2101 ps_char="$return \\$"
2102 ;;
2103 *) ps_color="$(get_term_color yellow)"
2104 ps_char="$return \\$"
2105 ;;
2106 esac
2107 if [[ ! -O . ]]; then # not owner
2108 if [[ -w . ]]; then # writable
2109 ps_color="$(get_term_color bold red)"
2110 else
2111 ps_color="$(get_term_color bold green)"
2112 fi
2113 fi
2114 # I would set nullglob, but bash has had bugs where that
2115 # doesnt work if not in top level.
2116 if [[ -e /nocow/btrfs-stale ]] && ((`command ls -AUq /nocow/btrfs-stale|wc -l`)); then
2117 ps_char="! $ps_char"
2118 fi
2119 PS1="${PS1%"${PS1#*[wW]}"} \[$ps_color\]$ps_char\[$(get_term_color nocolor)\] "
2120 # emacs completion doesnt like the git prompt atm, so disabling it.
2121 #PS1="${PS1%"${PS1#*[wW]}"}$(__git_ps1 ' (%s)') \[$ps_color\]$ps_char\[$(get_term_color nocolor)\] "
2122 }
2123 PROMPT_COMMAND=prompt-command
2124
2125 settitle () {
2126 if [[ $TERM == screen* ]]; then
2127 local title_escape="\033]..2;"
2128 else
2129 local title_escape="\033]0;"
2130 fi
2131 if [[ $* != prompt-command ]]; then
2132 echo -ne "$title_escape$USER@$HOSTNAME ${PWD/#$HOME/~} "
2133 printf "%s" "$*"
2134 echo -ne "\007"
2135 fi
2136 }
2137
2138 # for titlebar.
2139 # condition from the screen man page i think.
2140 # note: duplicated in tx()
2141 # disabled. see note in tx
2142 # if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2143 # trap 'settitle "$BASH_COMMAND"' DEBUG
2144 # else
2145 # trap DEBUG
2146 # fi
2147
2148 fi
2149
2150 reset-konsole() {
2151 # we also have a file in /a/c/...konsole...
2152 local f=$HOME/.config/konsolerc
2153 setini DefaultProfile profileian.profile "Desktop Entry" $f
2154 setini Favorites profileian.profile "Favorite Profiles" $f
2155 setini ShowMenuBarByDefault false KonsoleWindow $f
2156 setini TabBarPosition Top TabBar $f
2157 }
2158
2159 reset-sakura() {
2160 while read k v; do
2161 setini $k $v sakura /a/c/subdir_files/.config/sakura/sakura.conf
2162 done <<'EOF'
2163 colorset1_back rgb(33,37,39
2164 less_questions true
2165 audible_bell No
2166 visible_bell No
2167 disable_numbered_tabswitch true
2168 scroll_lines 10000000
2169 scrollbar true
2170 EOF
2171 }
2172
2173 reset-xscreensaver() {
2174 # except for spash, i set these by setting gui options in
2175 # xscreensaver-command -demo
2176 # then finding the corresponding option in .xscreensaver
2177 # spash, i happened to notice in .xscreensaver
2178 #
2179 # dpmsOff, monitor doesnt come back on using old free software supported nvidia card
2180 cat > /home/iank/.xscreensaver <<'EOF'
2181 mode: blank
2182 dpmsEnabled: True
2183 dpmsStandby: 0:02:00
2184 dpmsSuspend: 0:03:00
2185 dpmsOff: 0:00:00
2186 timeout: 0:02:00
2187 lock: True
2188 lockTimeout: 0:03:00
2189 splash: False
2190 EOF
2191
2192 }
2193
2194
2195 # * stuff that makes sense to be at the end
2196 if [[ "$SUDOD" ]]; then
2197 cd "$SUDOD"
2198 unset SUDOD
2199 elif [[ -d /a ]] && [[ $PWD == $HOME ]] && [[ $- == *i* ]]; then
2200 cd /a
2201 fi
2202
2203
2204 # best practice
2205 unset IFS
2206
2207
2208 # for mitmproxy to get a newer python.
2209 # commented until i want to use it because it
2210 # noticably slows bash startup
2211 #
2212 #if [[ $EUID != 0 && -e ~/.pyenv/bin ]]; then
2213 # export PATH="~/.pyenv/bin:$PATH"
2214 # eval "$(pyenv init -)"
2215 # eval "$(pyenv virtualenv-init -)"
2216 #fi
2217
2218
2219
2220 export GOPATH=$HOME/go
2221 path_add $GOPATH/bin
2222 path_add /usr/local/go/bin
2223
2224 export ARDUINO_PATH=/a/opt/Arduino/build/linux/work
2225
2226 path_add --end ~/.npm-global
2227
2228 # taken from default changes to bashrc and bash_profile
2229 path_add --end $HOME/.rvm/bin
2230 [[ -s "$HOME/.rvm/scripts/rvm" ]] && source "$HOME/.rvm/scripts/rvm" # Load RVM into a shell session *as a function*
2231
2232 export BASEFILE_DIR=/a/bin/fai-basefiles
2233
2234 export ANDROID_HOME=/opt/android
2235
2236 # didnt get drush working, if I did, this seems like the
2237 # only good thing to include for it.
2238 # Include Drush completion.
2239 # if [ -f "/home/ian/.drush/drush.complete.sh" ] ; then
2240 # source /home/ian/.drush/drush.complete.sh
2241 # fi
2242
2243
2244 # https://wiki.archlinux.org/index.php/Xinitrc#Autostart_X_at_login
2245 # i added an extra condition as gentoo xorg guide says depending on
2246 # $DISPLAY is fragile.
2247 if [[ ! $DISPLAY && $XDG_VTNR == 1 ]] && shopt -q login_shell && isarch; then
2248 exec startx
2249 fi
2250
2251
2252 # ensure no bad programs appending to this file will have an affect
2253 return 0